* Program....: PAYSCHED.PRG
* Version....: 1.0
* Author.....: Andrew Coates
* Date.......: January 30, 1999
* Notice.....: Copyright  1999 Civil Solutions,
*   All Rights Reserved.
* Compiler...: Visual FoxPro 06.00.8167.00 for Windows
* Abstract...: Prints a payment schedule for a fixed
*   rate loan given an annual interest rate, a number
*   of years over which the loan is taken, a loan
*   amount and a number of payments per year.
*   Uses the Excel functions PMT and IPMT
* Changes....:

LOCAL loExcel, lnAPR, lnLoanYears, lnLoanAmount, ;
  lnPaymentsPerYear

* set up values for calculations. In practice, you'd
* pass these as parameters or have them as properties
* of an object

lnAPR = 7.5
lnLoanYears = 10
lnLoanAmount = 250000
lnPaymentsPerYear = 2

loExcel = CREATE('excel.application')

* calculate the periodic payment
lnPayment = loExcel.worksheetfunction.pmt( ;
  (lnAPR/100)/lnPaymentsPerYear, ;
  lnPaymentsPerYear * lnLoanYears, ;
  lnLoanAmount)

* round the periodic payment to the nearest cent
lnPayment = ROUND(lnPayment, 2)

* clear the screen
CLEAR

* set up the headings
? 'Period', 'Payment', 'Interest'

* loop through the periods and calculate the interest;
* paid in each
FOR lnPeriod = 1 TO (lnPaymentsPerYear * lnLoanYears)
  lnInterest = loExcel.worksheetfunction.ipmt( ;
    (lnAPR/100)/lnPaymentsPerYear, ;
    lnPeriod, ;
    lnPaymentsPerYear * lnLoanYears, ;
    lnLoanAmount)

  * round the interest paid to the nearest cent
  lnInterest = ROUND(lnInterest, 2)

  * Print the info for this period
  ? TRANSFORM(lnPeriod), TRANSFORM(lnPayment, '@$'), TRANSFORM(lnInterest, '@$')

ENDFOR
