* Program....: RUNARCVIEW.PRG
* Version....: 1.0
* Author.....: Andrew Coates
* Date.......: February 1, 1999
* Notice.....: Copyright  1999 Civil Solutions, 
*   All Rights Reserved.
* Compiler...: Visual FoxPro 06.00.8167.00 for Windows
* Abstract...: Calls an ArcView script via DDE to print
*   the information for this patient
*   translated from VBA
* Assumes...: patientdata table open and record pointer
*   on correct record
* Changes....:

#INCLUDE foxpro.h

* This module sends data to ArcView via DDE to get it 
* to print a map. It passes the map number, randomised
* x and y values, the node fields comments (blank) and 
* the patient name and sex

* first, establish a connection to the dde server
nChan = DDEInitiate([ARCVIEW], [SYSTEM])
If nChan < 0 Then
    MessageBox ([Could Not Connect to ARCVIEW, Please ensure that it is running on this machine], MB_ICONEXCLAMATION)
    Return
EndIf

* build the ArcView command
cAVCOMMAND = [av.run('SinglePoint', {]

cAVCOMMAND = cAVCOMMAND + ltrim(Str(patientdata.MapNumber)) + [,]
cAVCOMMAND = cAVCOMMAND + ltrim(Str(patientdata.xValue)) + [,]
cAVCOMMAND = cAVCOMMAND + ltrim(Str(patientdata.yValue)) + [,]
cAVCOMMAND = cAVCOMMAND + [']+ ltrim(patientdata.nodes) + [','',]
cAVCOMMAND = cAVCOMMAND + ['] + ltrim(patientdata.patientname) + [, ] + ;
  upper(ltrim(patientdata.gender)) + ['})]

* now, run the script
cRetVal = Application.DDEExecute(nChan, cAVCOMMAND)

* check to see how the run went and display an error if it failed
If Left(cRetVal, 3) <> [Lay] Then
    msg = [Print Failed - Layout retained as ] + Trim(cRetVal) + [. Please print and delete it manually]
    answer = MessageBox(msg, MB_ICONEXCLAMATION, "Error Printing")
EndIf

* terminate the DDE conversation with ArcView
DDETerminate (nChan)

